﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

using System.Windows.Forms;

using System.Threading;
using System.Net.Http;
using System.Web;//此引用需专门右键引用添加
using System.Web.Http.SelfHost;
using System.Web.Http;
//引用自托管包
//Install-Package Microsoft.AspNet.WebApi.SelfHost -Version 5.2.7

//引入跨域包
//Install-Package Microsoft.AspNet.WebApi.Cors -Version 5.2.7 
namespace WebApiSelfHostAuthorization
{
    public partial class frmServer : Form
    {
        private HttpSelfHostServer server;//服务器对象
        public frmServer()
        {
            InitializeComponent();
        }
        private void Form1_Load(object sender, EventArgs e)
        {
            btnStop.Enabled = false;
            btnStart.Enabled = true;
        }

        private void btnStart_Click(object sender, EventArgs e)//启动服务
        {
            string sUrl = txtUrl.Text.Trim();
            try
            {
                HttpSelfHostConfiguration config = new HttpSelfHostConfiguration(sUrl);
                //配置跨域访问。一定要添加这个，才能使用EnableCorsAttribute,否则，在Contoler或者Action上面添加这个特性无效
                config.EnableCors(new System.Web.Http.Cors.EnableCorsAttribute("*", "*", "*"));//配置全局跨域
                //config.EnableCors();//为特定控制器或方法添加跨域特性
                config.MapHttpAttributeRoutes();
                
                config.Routes.MapHttpRoute(
                    name: "DefaultApi",
                    routeTemplate: "api/{controller}/{id}",
                    defaults: new { id = RouteParameter.Optional });
                    //constraints:null,
                    //handler:new BasicAuthorizationHandler());//可以为指定路由添加message handler。注意重载参数顺序


                config.MessageHandlers.Add(new BasicAuthorizationHandler());//全局HTTP Message Handler

                server = new HttpSelfHostServer(config);
                server.OpenAsync().Wait();
                lblState.Text = "web服务已经启动并运行中...";
                btnStop.Enabled = true;
                btnStart.Enabled = false;
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message);
            }
            
        }


        private void btnStop_Click(object sender, EventArgs e)//停止服务
        {
            try
            {
                server.CloseAsync().Wait();
                Thread.Sleep(1000);
                lblState.Text = "web服务已经停止";
                btnStop.Enabled = false;
                btnStart.Enabled = true;
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message);
            }
        }
    }
}
