﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

using System.Security.Cryptography;
namespace WebApi客户端加密身份验证
{
    /// <summary>
    /// DES加密，生成的是base64字符串
    /// </summary>
    public static class DES1
    {
        private const string pKey = "12345678";
        /// <summary>
        /// 加密
        /// </summary>
        /// <param name="StrOrign">待加密字符串，字符、数字、中文等</param>
        /// <returns>返回base64字符串</returns>
        public static string Encrypt(string StrOrign)
        {
            DESCryptoServiceProvider des = new DESCryptoServiceProvider();
            byte[] inputByteArray;
            inputByteArray = System.Text.Encoding.UTF8.GetBytes(StrOrign);
            // @#建立加密对象的密钥和偏移量
            // @#原文使用ASCIIEncoding.ASCII方法的GetBytes方法
            // @#使得输入密码必须输入英文文本
            des.Key = System.Text.Encoding.UTF8.GetBytes(pKey);
            des.IV = System.Text.Encoding.UTF8.GetBytes(pKey);
            des.Mode = CipherMode.ECB;
            des.Padding = PaddingMode.PKCS7;
            // @#写二进制数组到加密流
            // @#(把内存流中的内容全部写入)
            System.IO.MemoryStream ms = new System.IO.MemoryStream();
            CryptoStream cs = new CryptoStream(ms, des.CreateEncryptor(des.Key, des.IV), CryptoStreamMode.Write);
            // @#写二进制数组到加密流
            // @#(把内存流中的内容全部写入)
            cs.Write(inputByteArray, 0, inputByteArray.Length);
            cs.FlushFinalBlock();

            // '将8位无符号整数数组的值转换成用Base64数字编码的等效字符串表现形式，字符包含：A-Z a-z 0-9 + / 无值字符"="用于尾部空白
            byte[] bytes = ms.ToArray();
            string ret = Convert.ToBase64String(bytes);

            des.Dispose();
            cs.Dispose();
            ms.Dispose();
            return ret;
        }
        /// <summary>
        /// 解密。注意判断传入参数的有效性，非base64字符串会报错，建议try-catch捕捉异常
        /// </summary>
        /// <param name="StrOrigin">待解密字符串，base64字符串</param>
        /// <returns>返回原始字符串</returns>
        public static string Decrypt(string StrOrigin)
        {
            DESCryptoServiceProvider des = new DESCryptoServiceProvider();           
            byte[] inputByteArray = Convert.FromBase64String(StrOrigin); // 将base64字符串转换为16进制字节数组
            // @#建立加密对象的密钥和偏移量，此值重要，不能修改
            des.Key = System.Text.Encoding.UTF8.GetBytes(pKey);
            des.IV = System.Text.Encoding.UTF8.GetBytes(pKey);
            des.Mode = CipherMode.ECB;
            des.Padding = PaddingMode.PKCS7;
            System.IO.MemoryStream ms = new System.IO.MemoryStream();
            CryptoStream cs = new CryptoStream(ms, des.CreateDecryptor(des.Key,des.IV), CryptoStreamMode.Write);
            cs.Write(inputByteArray, 0, inputByteArray.Length);
            cs.FlushFinalBlock();
            des.Dispose();
            cs.Dispose();
            ms.Dispose();
            return System.Text.Encoding.UTF8.GetString(ms.ToArray());
        }
    }
}
